/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Tramo;
import com.rjconsultores.ventaboletos.entidad.TramoKmServicio;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.TramoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTramoKmServicio;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Paging;

/**
 *
 * @author Desenolvimento
 */
@Controller("busquedaTramoKmServicioController")
@Scope("prototype")
public class BusquedaTramoKmServicioController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TramoKmServicio> plwTramoKmServicio;
    @Autowired
    private EmpresaService empresaService;
    @Autowired
    private TramoService tramoService;
    @Autowired
    private ClaseServicioService claseServicioService;
    private MyListbox tramoKmServicioList;
    private Paging pagingTramoKmServicio;
//    private Combobox cmbTramo;
    private Combobox cmbEmpresa;
    private Combobox cmbClaseServicio;
    private Combobox cmbParadaOrigem;
    private Combobox cmbParadaDestino;
    private List<Tramo> lsTramo;
    private List<Empresa> lsEmpresa;
    private List<ClaseServicio> lsClaseServicio;

    public Paging getPagingTramoKmServicio() {
        return pagingTramoKmServicio;
    }

    public void setPagingTramoKmServicio(Paging pagingTramoKmServicio) {
        this.pagingTramoKmServicio = pagingTramoKmServicio;
    }

    public MyListbox getTramoKmServicioList() {
        return tramoKmServicioList;
    }

    public void setTramoKmServicioList(MyListbox tramoKmServicioList) {
        this.tramoKmServicioList = tramoKmServicioList;
    }

    public PagedListWrapper<TramoKmServicio> getPlwTramoKmServicio() {
        return plwTramoKmServicio;
    }

    public void setPlwTramoKmServicio(PagedListWrapper<TramoKmServicio> plwTramoKmServicio) {
        this.plwTramoKmServicio = plwTramoKmServicio;
    }

    public List<ClaseServicio> getLsClaseServicio() {
        return lsClaseServicio;
    }

    public void setLsClaseServicio(List<ClaseServicio> lsClaseServicio) {
        this.lsClaseServicio = lsClaseServicio;
    }

    public List<Empresa> getLsEmpresa() {
        return lsEmpresa;
    }

    public void setLsEmpresa(List<Empresa> lsEmpresa) {
        this.lsEmpresa = lsEmpresa;
    }

    public List<Tramo> getLsTramo() {
        return lsTramo;
    }

    public void setLsTramo(List<Tramo> lsTramo) {
        this.lsTramo = lsTramo;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        lsEmpresa = empresaService.buscarTodosExceto(UsuarioLogado.getUsuarioLogado().getEmpresa(),-1);
        lsClaseServicio = claseServicioService.buscarTodosExceto(-1);
//        lsTramo = tramoService.obtenerTodos();

        super.doAfterCompose(comp);

        tramoKmServicioList.setItemRenderer(new RenderTramoKmServicio());
        tramoKmServicioList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TramoKmServicio c = (TramoKmServicio) tramoKmServicioList.getSelected();
                verTramoKmServicio(c);
            }
        });

        refreshLista();

    }

    private void verTramoKmServicio(TramoKmServicio t) {
        if (t == null) {
            return;
        }

        Map args = new HashMap();
        args.put("tramoKmServicio", t);
        args.put("tramoKmServicioList", tramoKmServicioList);

        openWindow("/gui/esquema_operacional/editarTramoKmServicio.zul",
                Labels.getLabel("editarTramoKmServicioController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<TramoKmServicio> tramoBusqueda =
                new HibernateSearchObject<TramoKmServicio>(TramoKmServicio.class,
                pagingTramoKmServicio.getPageSize());

        Comboitem cbiEmpresa = cmbEmpresa.getSelectedItem();
        if (cbiEmpresa != null) {
            Empresa empresa = (Empresa) cbiEmpresa.getValue();
            tramoBusqueda.addFilterEqual("empresa", empresa);
        }else{
			tramoBusqueda.addFilterIn("empresa", lsEmpresa);
		}

        Comboitem cbiClaseServicio = cmbClaseServicio.getSelectedItem();
        if (cbiClaseServicio != null) {
            ClaseServicio clase = (ClaseServicio) cbiClaseServicio.getValue();
            tramoBusqueda.addFilterEqual("claseServicio", clase);
        }

        Comboitem cbiOrigem = cmbParadaOrigem.getSelectedItem();
        if (cbiOrigem != null) {
            Parada origem = (Parada) cbiOrigem.getValue();
            tramoBusqueda.addFilterEqual("tramo.origem", origem);
        }
        Comboitem cbiDestino = cmbParadaDestino.getSelectedItem();
        if (cbiDestino != null) {

            Parada destino = (Parada) cbiDestino.getValue();
            tramoBusqueda.addFilterEqual("tramo.destino", destino);
        }

//        Comboitem cbiTramo = cmbTramo.getSelectedItem();
//        if (cbiTramo != null) {
//            Tramo tramo = (Tramo) cbiTramo.getValue();
//            tramoBusqueda.addFilterEqual("tramo", tramo);
//        }


        tramoBusqueda.addSortAsc("tramokmservicioId");
        tramoBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwTramoKmServicio.init(tramoBusqueda, tramoKmServicioList, pagingTramoKmServicio);

        if (tramoKmServicioList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaTramoKmServicioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTramoKmServicio(new TramoKmServicio());
    }
}
